use crate::track::Track;
use serde::{Deserialize, Serialize};

fn default_vec() -> Vec<Track> {
    Vec::new()
}

#[derive(Serialize, Deserialize, Debug)]
pub struct Playlist {
    pub id: String,
    pub name: String,
    #[serde(rename = "songCount")]
    pub song_count: usize,
    #[serde(default = "default_vec")]
    pub entry: Vec<Track>,
}
